#!/usr/bin/tcc -run
#include <stdio.h>

/* not sure if this'll work as well as it ought to */
/* the header parser is very flaky, and will only accept very specific
   header contents. Should fix this some time */

typedef unsigned char byte;
void badheader();
void eatwspace();

int main() {
   int i=0,l,r,ch;
   char out,want;
   char *header="P6_64_96_255";
   while(i<strlen(header)) {

      fprintf(stderr,"repackrgb.c reading header\n");
      want=*(header+i);
      if(want=='_') {
         eatwspace();
         i++;continue;
      }
      ch=getchar();
      if(ch!=want) {
        fprintf(stderr,"repackrgb.c: wanted %c, got %c.\n",want,ch);
        badheader();
      }
      i++;
   }
   /* now expect 1 single byte of whitespace, which we eat, or exit if not */
   fprintf(stderr,"repackrgb.c stage 1\n");
   if(!isspace(getchar())) badheader();
   /* now we have data. */
   fprintf(stderr,"repackrgb.c stage 2\n");

   while(l=getchar(),r=getchar(),(l!=-1&&r!=-1)) {
      out=(byte)(l&0xF0);
      out|=((byte)(r&0xF0)>>4);
      printf("%c",out);
/*      printf("%c",(byte)(i&0xF0));
        printf("%c",(byte)(i&0x0F)<<4); */
   }
   fprintf(stderr,"repackrgb12 completed.\n");
}

void badheader() {
   fprintf(stderr,"repackrgb12 ERROR: Expected input is 96x64 raw PPM with"
    " Maxval of 255.Quitting.\n");
   exit(1);
}

/* consume as many whitespace bytes as can be found. If *none* is found,
   call badheader(). Once non-whitespace is found, push it back to be
   read again later. */
void eatwspace() {
   int ch;
   fprintf(stderr,"repackrgb12 checking whitespace\n");
   if (!isspace(getchar())) badheader(); /* we want at least one byte worth! */

   fprintf(stderr,"repackrgb12 eating any further whitespace\n");
   while(ch=getchar(),isspace(ch)) ;
   fprintf(stderr,"repackrgb12 pushing back character...\n");
   ungetc(ch,stdin);
   /* hope this works!! */
   fprintf(stderr,"repackrgb12, pushed back character.\n");
}

